__package__    = "pocketphone/vcard/__init__.py"
__version__    = "1.0"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/pocketphone"
__date__       = "$Date: 2008/11/02 05:50:56 $"
__copyright__  = "Copyright (c) 2007-2008 Aaron Straup Cope. BSD license : http://www.modestmaps.com/license.txt"

# http://pypi.python.org/pypi/vobject/

import os
import os.path

import vobject
import pocketphone

class vcard (pocketphone.pocketphone) :

    # ################################################

    def add_directory (self, path, extension=".vcf") :

        for root, dirs, files in os.walk(path) :
            for file in files :
                if file.endswith(extension) :
                    self.add_vcard(os.path.join(root, file))
                    
    # ################################################
    
    def add_vcards (self, vcards) :
        for path in vcards :
            self.add_vcard(path)

    # ################################################
    
    def add_vcard (self, path) :

        fh = open(path)
        txt = fh.read()
        fh.close()

        try :
            vcard = vobject.readOne(txt)
        except Exception, e:
            print "failed to read %s. error was: %s" % (path, e)
            return

        # print vcard.prettyPrint()
        
        fn = vcard.fn.value
        
        for child in vcard.getChildren() :

            if child.name == 'TEL' :
                number = child.value
                params = child.params

                if params.has_key('TYPE') :
                    type = ",".join(params['TYPE'])
                    name = "%s (%s)" % (fn, type.lower())

                if number :
                    self.add_number({'name':unicode(name), 'number':unicode(number)})        

    # ################################################
